#!/usr/bin/env bash

# Enable DEVX
mst start
MST_DEVICES=$(mst status | grep -Po '/dev/mst/[^ ]*(?= )')
for dev in $MST_DEVICES; do
    echo "Enabling DEVX for device $dev"
    mcra "$dev" 0x3ce4.7 1
done
modprobe -r mlx5_ib mlx5_core
modprobe mlx5_ib

# Bind disks to user space driver
PCI_DEVICES=$(grep -Po '(?<=traddr:).*(?=")' $CONFIG)
echo "Binding devices to user space driver: $PCI_DEVICES"
PCI_WHITELIST="$PCI_DEVICES" /usr/share/spdk/scripts/setup.sh

# Setup hugepages
HP_SIZE=$(grep -Po 'Hugepagesize: *\K[0-9]*(?= )' /proc/meminfo)

# Remove previously used hugepages
rm -f /dev/hugepages/spdk_pid*

# Assume we need 16GB of hugepages
NEED_GB=16
NEED_PAGES=$(( $NEED_GB*1024*1024 / $HP_SIZE ))
FREE_PAGES=$(cat /sys/kernel/mm/hugepages/hugepages-${HP_SIZE}kB/free_hugepages)
ADD_PAGES=$(( $NEED_PAGES - $FREE_PAGES ))
if [ $ADD_PAGES -ge 0 ]; then
    NR_PAGES=$(cat /sys/kernel/mm/hugepages/hugepages-${HP_SIZE}kB/nr_hugepages)
    NR_PAGES=$(( $NR_PAGES + $ADD_PAGES ))
    echo "Adding $ADD_PAGES hugepages. New number is $NR_PAGES"
    echo $NR_PAGES > /sys/kernel/mm/hugepages/hugepages-${HP_SIZE}kB/nr_hugepages
fi
